/* Restricts choosing autoassign in team menu 06.01.2005 [WING] Black Knight */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define MAX_OPT_LENGTH 3

new STRING_VERSION[MAX_DATA_LENGTH] = "1.0beta";
new g_User[MAX_PLAYERS];
new g_noautoassign=0;

public plugin_disconnect(HLUserName,UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public HandleChooseTeam(HLCommand,HLData,HLUserName,UserIndex) {
	g_User[UserIndex]=1;
	return PLUGIN_CONTINUE;
}

public HandleJoinTeam(HLCommand,HLData,HLUserName,UserIndex) {
	new sData[MAX_DATA_LENGTH];
	new sCommand[MAX_COMMAND_LENGTH];
	new sUser[MAX_NAME_LENGTH];

	convert_string(HLData,sData,MAX_DATA_LENGTH);
	convert_string(HLCommand,sCommand,MAX_DATA_LENGTH);

	if(( streq(sCommand,"jointeam") || g_User[UserIndex]) &&  sData[0]=='5' && g_noautoassign){
		convert_string(HLUserName,sUser,MAX_DATA_LENGTH);
		messageex(sUser,"It's your choice, not mine!",print_center);
		execclient(sUser,"chooseteam");
		return PLUGIN_HANDLED;
	}
	g_User[UserIndex]=0;

	return PLUGIN_CONTINUE;
}

public admin_noautoassign(HLCommand,HLData,HLUserName,UserIndex) { 
	new sData[MAX_DATA_LENGTH]; 
	convert_string(HLData,sData,MAX_NAME_LENGTH); 
	if(streq(sData,"on") && streq(sData,"off")){
		selfmessage("Valid options for admin_autoassign are on or off");
	}
	else{
		set_vaultdata("BK_NOAUTOASSIGN",sData);
		if(streq(sData,"on")){
			g_noautoassign=1;
		}
		else {
			g_noautoassign=0;
		}
		snprintf(sData,MAX_DATA_LENGTH,"Autoassign is now %s!",sData);
		selfmessage(sData);
	}
	return PLUGIN_HANDLED; 
}

public plugin_init() {
	new sAutoSelect[MAX_OPT_LENGTH];

	plugin_registerinfo("No Autoassign", "Restricts choosing autoassign in team menu.", STRING_VERSION);
	plugin_registercmd("admin_noautoassign","admin_noautoassign",ACCESS_BAN,"admin_noautoassign <on/off>: enables and disables autoassign");
	plugin_registercmd("chooseteam", "HandleChooseTeam", ACCESS_ALL);
	plugin_registercmd("jointeam", "HandleJoinTeam", ACCESS_ALL);
	plugin_registercmd("menuselect", "HandleJoinTeam", ACCESS_ALL);
	plugin_registercmd("specmode","HandleChooseTeam",ACCESS_ALL);

	if(!get_vaultdata("BK_NOAUTOASSIGN",sAutoSelect,MAX_OPT_LENGTH) && strlen(sAutoSelect) < MAX_OPT_LENGTH-1){
		set_vaultdata("BK_NOAUTOASSIGN","on");
	}

	if(streq(sAutoSelect,"on")){
		g_noautoassign=1;
	}

	return PLUGIN_CONTINUE;
}
